/*
--------------------------------------------------------------------------
(c) 2007 Lawrence Akka
 - jquery version of the spamspan code (c) 2006 SpamSpan (www.spamspan.com)

This program is distributed under the terms of the GNU General Public
Licence version 2, available at http://www.gnu.org/licenses/gpl.txt
--------------------------------------------------------------------------
*/

((Drupal, $) => {
  // load SpamSpan
  Drupal.behaviors.spamspan = {
    attach: (context) => {
      // get each span with class spamspan
      $('span.spamspan', context).each(function () {
        // Replace each <span class='o'></span> with .
        if ($('span.o', this).length) {
          $('span.o', this).replaceWith('.');
        }

        // For each selected span, set mail to the relevant value, removing spaces
        const _mail = (
          $('span.u', this).text() +
          '@' +
          $('span.d', this).text()
        ).replace(/\s+/g, '');

        // Build the mailto URI
        let _mailto = 'mailto:' + _mail;
        if ($('span.h', this).length) {
          // Find the header text, and remove the round brackets from the start and end
          const _headerText = $('span.h', this)
            .text()
            .replace(/^ ?\((.*)\) ?$/, '$1');

          // split into individual headers, and return as an array of header=value pairs
          const _headers = $.map(_headerText.split(/, /), (n) => n.replace(/: /, '='));

          const _headerString = _headers.join('&');
          if (_headerString) {
            _mailto += '?' + _headerString;
          }
        }

        // Find the anchor content, and remove the round brackets from the start and end
        let _anchorContent = $('span.t', this).html();
        if (_anchorContent) {
          _anchorContent = _anchorContent.replace(/^ ?\(([^]*)\) ?$/, '$1');
        }

        // create the <a> element, and replace the original span contents

        // check for extra <a> attributes
        const _attributes = $('span.e', this).html();
        let _tag = '<a></a>';
        if (_attributes) {
          _tag = `<a ${_attributes}></a>`;
        }

        $(this)
          .after(
            $(_tag)
              .attr('href', _mailto)
              .html(_anchorContent ? _anchorContent : _mail)
              .addClass('spamspan')
          )
          .remove();
      });
    },
  };
})(Drupal, jQuery);
